#include <windows.h>
#include <stdio.h>
#include "applicom.h"

short i;	    /* For loop counter	*/
short nchan;	/* Channel number	*/
short neq;	    /* Equipment number	*/
short nb;	    /* Number of bytes	*/
short status;	/* Interchange status	*/
long adr;	    /* First byte address	*/
char tabl[2];	/* Table containing the data. Al piu' sono 2 byte perche' i device leggono/scrivono 2 bytes alla volta	*/
long int tabella[2];
int answer;

void continua()
{
   int x;
   
   do {
      printf("\n  Inserisci 0 per continuare ----->");
      scanf("%d",&x);
   } while (x);

}

void main()
{
  initbus(&status);
  if (!status)
  {

	  nchan=0; 

	  do {
            
            printf("\n\n\n\n MENU ");
			printf("\n\n\n OPERAZIONI SU I/O SAIA \n");
			printf("\n0 - SCRITTURA di due byte sulle USCITE modulo SAIA RIO 16O DP");
			printf("\n1 - SCRITTURA di un solo byte sulle USCITE del SAIA RIO 16O DP");
			printf("\n2 - LETTURA di due byte sulle USCITE modulo SAIA RIO 16O DP");
			printf("\n3 - LETTURA di un solo byte sulle USCITE del SAIA RIO 16O DP");
			printf("\n4 - LETTURA di due byte dagli INGRESSI del SAIA RIO 16I DP ");
			printf("\n5 - LETTURA di un solo byte dagli INGRESSI del SAIA RIO 16I DP");
			printf("\n\n\n OPERAZIONI SU PLC PCD1 \n");
			printf("\n6 - SCRITTURA di 1 byte su 8 flag consecutivi del PLC PCD1");
			printf("\n7 - LETTURA di un byte dagli ingressi del PLC PCD1");
            
			printf("\n8 - Fine ");
			printf("\n  Inserisci la tua scelta ----->");
			scanf("%d",&answer);

			switch(answer) {
			     case 0 : {  
		             printf("\n  SCRITTURA di due byte contemporaneamente sul SAIA RIO 16O DP");
			         adr=0;
 		             nb=2;
					 neq=3; 
			         printf("\n  Il numero di equipment dove scrivo e' = %d ",neq);

					 
                     for (i=0; i<2; i++) {
                          printf("\nValore del byte numero %ld (-128 +127) = ",i);
                          scanf(" %hd", &tabl[i]);
					 }
						 
                     writepackqbyte(&nchan, &neq, &nb, &adr, tabl, &status);
                     if (status)
                         printf("\n problemi relativi all'equipment numero %hd \n",neq);

                     continua(); 
					 break;
					}
				 case 1: {	 
			         printf("\n  SCRITTURA di un solo byte sul SAIA RIO 16O DP");
                     printf("\n  Valore del byte da scrivere (-128 +127) = ");
                     scanf(" %hd", &tabl[0]);
   		             printf("\n  Valore dell'address byte (0-1) = ");
                     scanf(" %ld", &adr);
                     nb=1;
                     neq=3;
			         printf("\n  Il numero di equipment dove scrivo e' = %d ",neq);

                     writepackqbyte(&nchan, &neq, &nb, &adr, tabl, &status);
                     if (status)
                          printf("\n problemi relativi all'equipment numero %hd \n",neq);

                     continua(); 
					 break;
					}    

                 case 2: {
					 printf("\n  LETTURA di due byte contemporaneamente dal SAIA RIO 16O DP");
			
			         adr=0;
 		             nb=2;
					 neq=3;
			         printf("\n  Il numero di equipment da dove leggo e' = %d ",neq);

                     readpackqbyte(&nchan, &neq, &nb, &adr, tabl, &status);
                     if (status)
                         printf("\n problemi relativi all'equipment numero %hd \n",neq);
                     else for (i=0; i<2; i++) {
                          printf("\n  Valore del byte numero %ld = ",i);
                          printf(" %hd\n", tabl[i]);
					 }

                     continua(); 
                     break;
					}
				 case 3: {
					 printf("\n  LETTURA di un solo byte dal SAIA RIO 16O DP");
			
 		             nb=1;
					 neq=3;
			         printf("\n  Il numero di byte che leggo e' = %d ",nb);
			         printf("\n  Il numero di equipment da dove leggo e' = %d ",neq);

			         printf("\n  Inserisci il valore dell'address byte (0-1) ");
					 scanf(" %ld" , &adr);

                     readpackqbyte(&nchan, &neq, &nb, &adr, tabl, &status);
                     if (status)
                         printf("\n problemi relativi all'equipment numero %hd \n",neq);
                     else {
						  printf("\n  Valore del byte numero %ld = ",adr);
                          printf(" %hd\n", tabl[0]);
					 }
                     
					 continua(); 
                     break;
					}

				 
				 case 4: {
					 printf("\n  LETTURA di due byte contemporaneamente dal SAIA RIO 16I DP");
			
			         adr=0;
 		             nb=2;
					 neq=2;
			         printf("\n  Il numero di equipment da dove leggo e' = %d ",neq);

                     readpackibyte(&nchan, &neq, &nb, &adr, tabl, &status);
                     if (status)
                         printf("\n problemi relativi all'equipment numero %hd \n",neq);
                     else for (i=0; i<2; i++) {
                          printf("\n  Valore del byte numero %ld = ",i);
                          printf(" %hd\n", tabl[i]);
					 }
					 continua(); 
					 break;
					}
				 case 5: {
					 printf("\n  LETTURA di un solo byte dal SAIA RIO 16I DP");
			
 		             nb=1;
					 neq=2;
			         printf("\n  Il numero di byte che leggo e' = %d ",nb);
			         printf("\n  Il numero di equipment da dove leggo e' = %d ",neq);

			         printf("\n  Inserisci il valore dell'address byte (0-1) ");
					 scanf(" %ld" , &adr);

                     readpackibyte(&nchan, &neq, &nb, &adr, tabl, &status);
                     if (status)
                         printf("\n problemi relativi all'equipment numero %hd \n",neq);
                     else {
						  printf("\n  Valore del byte numero %ld = ",adr);
                          printf(" %hd\n", tabl[0]);
					 }

					 continua(); 
					 break;
					}
    			 case 6: {
					 printf("\n  SCRITTURA di 1 byte su 8 flag interni del PLC PCD1");
					 
 		             nb=1;
					 neq=1;
                     adr=0;
			         printf("\n  Il numero di equipment dove scrivo e' = %d ",neq);
                     
					 printf("\n  Valore del byte che devo scrivere (-128 +127) = ");
                     scanf(" %hd", &tabl[adr]);
                     writepackqbyte(&nchan, &neq, &nb, &adr, tabl, &status);
					 continua(); 
                     break;

					}

				 case 7: {
					 printf("\n  LETTURA di un 1 byte dagli ingressi del PLC PCD1");
		             printf("\n  Gli ingressi disponibili sul PLC PCD1 sono di un solo byte ");
			
					 
 		             nb=1;
					 neq=1;
					 adr=0;
			         printf("\n  Il numero di equipment da dove leggo e' = %d ",neq);
			         printf("\n  Il valore dell'address byte e' %d = ", adr);

                     readpackibyte(&nchan, &neq, &nb, &adr, tabl, &status);
                     if (status)
                         printf("\n problemi relativi all'equipment numero %hd \n",neq);
                     else {
						  printf("\n  Valore del byte letto = ");
                          printf(" %hd\n", tabl[adr]);
					 }
 
					 continua(); 
					 break;
					}

				}
			} while (answer<8);
	  
	  exitbus(&status);
  }
  else
    printf(" non-resident applicom communication software ");

}
